chrome.storage.local.get('pauseAndPlay', function(result) {
	if (result.pauseAndPlay != true && result.pauseAndPlay != false)
		chrome.storage.local.set({'pauseAndPlay': true});
});

chrome.runtime.onInstalled.addListener(function(details){
    if (details.reason == "install") {
		chrome.storage.local.set({'pauseAndPlay': true});
        chrome.storage.local.set({'ytbuttons': true});
		chrome.storage.local.set({'secstyle': true});
		chrome.storage.local.set({'linkYoutubePlay': true});
		chrome.tabs.create({ 'url': chrome.extension.getURL('options.html') });
    }
});

function play(url) {
	chrome.tabs.query( {currentWindow: true, active : true}, function(tab) {
		chrome.tabs.executeScript(tab[0].id, {code: "var url = 'potplayer://" + url + "'; window.open(url, '_self');"}, function() {
			chrome.tabs.executeScript(tab[0].id, {code: "location.href='javascript:SetPauseAndPlay(); void 0';"});
		})
	});
}

function add(url) {
	chrome.tabs.query( {currentWindow: true, active : true}, function(tab) {
		chrome.tabs.executeScript(tab[0].id, {code: "var url = 'potplayer://" + url + " /ADD'; window.open(url, '_self');"});
	});
}

chrome.contextMenus.onClicked.addListener(function(info, tab) {
	if (info.menuItemId === "pageYoutube" || info.menuItemId === "playlistYoutube") {
		play(info.pageUrl);
	}
	else if (info.menuItemId === "anyLinkOpen" || info.menuItemId === "linkYoutubePlay") {
		play(info.linkUrl);
	}
	else if (info.menuItemId === "anyLinkAdd" || info.menuItemId === "linkYoutubeAdd") {
		add(info.linkUrl);
	}
});

var cmY,cmPY,cmAO,cmAA,cmYP,cmYA;

if (cmY !== "pageYoutube") {
	cmY = chrome.contextMenus.create({
		title: chrome.i18n.getMessage('pageUrlPlay'),
		id: 'pageYoutube',
		contexts: ["page", "frame", "selection", "editable", "video", "browser_action", "page_action"],
		documentUrlPatterns: ['*://*.youtube.com/watch*']
	});
}

if (cmPY !== "playlistYoutube") {
	cmPY = chrome.contextMenus.create({
		title: chrome.i18n.getMessage('playlistUrlPlay'),
		id: 'playlistYoutube',
		contexts: ["page", "frame", "selection", "editable", "video", "browser_action", "page_action"],
		documentUrlPatterns: ['*://*.youtube.com/playlist*']
	});
}

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
	if (request.potplayer == "play") {
		play(request.redirect);
	} else if (request.potplayer == "add") {
		add(request.redirect);
	} else if (request.anyLinkOpen && cmAO !== "anyLinkOpen") {
		cmAO = chrome.contextMenus.create({
			title: chrome.i18n.getMessage('linkOpen'),
			id: 'anyLinkOpen',
			contexts: ['link']
		});
		if (cmYP === "linkYoutubePlay") {
			cmYP = chrome.contextMenus.remove('linkYoutubePlay');
		}
	} else if (request.anyLinkOpen == false && cmAO === "anyLinkOpen") {
		cmAO = chrome.contextMenus.remove('anyLinkOpen');
		chrome.storage.local.get('linkYoutubePlay', function(result) {
			if (result.linkYoutubePlay == true)
				chrome.runtime.sendMessage({linkYoutubePlay: true});
		});
	} else if (request.anyLinkAdd && cmAA !== "anyLinkAdd") {
		cmAA = chrome.contextMenus.create({
			title: chrome.i18n.getMessage('linkAdd'),
			id: 'anyLinkAdd',
			contexts: ['link']
		});
		if (cmYA === "linkYoutubeAdd") {
			cmYA = chrome.contextMenus.remove('linkYoutubeAdd');
		}
	} else if (request.anyLinkAdd == false && cmAA === "anyLinkAdd") {
		cmAA = chrome.contextMenus.remove('anyLinkAdd');
		chrome.storage.local.get('linkYoutubeAdd', function(result) {
			if (result.linkYoutubeAdd == true) {
				chrome.runtime.sendMessage({linkYoutubeAdd: true});
			}
		});
	} else if (request.linkYoutubePlay && cmYP !== "linkYoutubePlay" && cmAO !== "anyLinkOpen") {
		cmYP = chrome.contextMenus.create({
			title: chrome.i18n.getMessage('linkOpen'),
			id: 'linkYoutubePlay',
			contexts: ['link'],
			targetUrlPatterns: ['*://*.youtube.com/watch*', '*://*.youtube.com/playlist*', '*://*.youtube.com/embed*', '*://*.youtu.be/*']
		});
	} else if (request.linkYoutubePlay == false && cmYP === "linkYoutubePlay") {
		cmYP = chrome.contextMenus.remove('linkYoutubePlay');
	} else if (request.linkYoutubeAdd && cmYA !== "linkYoutubeAdd" && cmAA !== "anyLinkAdd") {
		cmYA = chrome.contextMenus.create({
			title: chrome.i18n.getMessage('linkAdd'),
			id: 'linkYoutubeAdd',
			contexts: ['link'],
			targetUrlPatterns: ['*://*.youtube.com/watch*', '*://*.youtube.com/playlist*', '*://*.youtube.com/embed*', '*://*.youtu.be/*']
		});
	} else if (request.linkYoutubeAdd == false && cmYA === "linkYoutubeAdd") {
		cmYA = chrome.contextMenus.remove('linkYoutubeAdd');
	}
});